const fs = require('fs')
const path = require('path')
const { deepListDirSync } = require('deep-list-dir')

//获取过滤条件方法
function getConditions (type) {
  let argv = process.argv
  let list = []
  for (let i = 0; i < argv.length; i++) {
    if (argv[i].indexOf(type) != -1) {
      let arr = argv[i].split('=')
      list.push(arr[1])
    }
  }
  return list
}

//获取需要过滤的条件
function getRegular () {
  let conditions = getConditions('--exceed')
  let conditions_str = conditions.join('|')
  return conditions_str.replace(/\//g, '\\/') //拼凑正则表达式
}

//扫描src文件下所有路径
let allList = deepListDirSync(getConditions('--dir')[0], {})

//读取有用文件列表并存到集合里
let pathSet = new Set()
let file = fs.readFileSync(path.join(__dirname, '../../../use-list.txt'), 'utf8')
file = file.split('\n')
for (let i = 0; i < file.length; i++) {
  pathSet.add(file[i].substr(1))
}

//获取无用的文件
for (let i = 0; i < allList.length; i++) {
  if (!pathSet.has(allList[i]) && !(allList[i].match(getRegular()))) {
    //如果不在有用文件列表,又不符合过滤条件
    let link = allList[i].replace(/\\/g, '/') //兼容window路径
    fs.appendFileSync('test.html', `<a href="${link}"></a>\n`, 'utf-8')
  }
}
