const pluginName = 'UnusedFindPlugin'
const fs = require('fs')
const MD5 = require('md5-node')

let pathSet = new Set()

function takeQuery (path) {
  let arr = path.split('?')
  return arr[0]
}

function savePath (path) {
  path = takeQuery(path)
  let key = MD5(path)
  if (pathSet.has(key)) {
    return
  }
  pathSet.add(key)
  fs.appendFileSync('use-list.txt', `${path}\n`, 'utf-8')
}

class UnusedFind {
  handleBuildModule (module) {
    const { userRequest } = module
    if (!userRequest) {
      return
    }
    const rawRequest = userRequest.replace(process.cwd(), '')
    if (rawRequest.includes('node_modules')) {
      return
    }
    //console.log(rawRequest)

    savePath(rawRequest)
  }

  apply (compiler) {
    compiler.hooks.compilation.tap(
      pluginName,
      compilation => {
        compilation.hooks.buildModule.tap(
          pluginName,
          this.handleBuildModule.bind(this)
        )
      })
  }
}

module.exports = UnusedFind
